#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                          -*-  ADA TDP Compilation -*-                        #
#                                                                              #
#                                                                              #
#                                                                              #
#  Perl-Script         AdaTDP.pl                                               #
#  Version             v3.4                                                    #
#                                                                              #
#  $Revision: 1.22 $                                                            #
#  $Date: 2008/05/15 17:19:22 $                                                #
#                                                                              #
#  launch probe analyzor to generate files before source compilations          #
#                                                                              #
#  Usage:                                                                      #
#       perl AdaTDP.pl <environment file>                                      #
#                                                                              #
#  Problems:                                                                   #
#                                                                              #
################################################################################

use FileHandle ;
STDOUT->autoflush(1);
STDERR->autoflush(1);

# Configuration file
require $ARGV[0];

# Miscellaneous functions
require $SCRIPTDIR . "Fcts.pl";

#die &PerlTranslate("Products.pl", "Unknown TDP... check configuration\n%1\n\n","%1 is the TDP path",$TARGETDIR) unless (-d $TARGETDIR);
die Unknown_TDP() unless (-d $TARGETDIR);

# Attol tools functions
require $SCRIPTDIR . "Tools.pl";

# Target-dependant functions
require $TARGETDIR . "/cmd/atl_func.pl";
require $TARGETDIR . "/cmd/atl_cc.pl";

################################################################################
# Here is the beginning
################################################################################
CheckIntDir();
EnterInScript();
ClearLogFile($LOGFILENAME);
PutProbeSetting();
###########################################################################
# This routine analyze the command line of script
sub CommandLineAnalyze
{
  return (1);
}

###########################################################################
# Print the USAGE
sub AttolCommandUsage #()
{
   die &PerlTranslate("AdaTDP.pl", "Use command like that : perl AdaTDP.pl <environment file> <file> \nExiting\n");
}

###########################################################################
# Decide what to do

# analyze command line to get phases
CommandLineAnalyze() || AttolCommandUsage();

print &PerlTranslate("AdaTDP.pl", "Checking the Ada TDP runtime files...\n");

#------------------------------------------------------------------------
# Prepare/Compile Ada TDP.
my $is_ada=0;
if ($TDP_LANGUAGE=~/^ADA/ )
{
  $is_ada = 1;
  TDPAdaGenerate ( $TDP_LANGUAGE );
  unlink("adalink.alk"); #make sure it will be updated
}
    
exit(0);
#
###############################################################################




