#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2008 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                        -*-  System Testing report -*-                        #
#                                                                              #
#                                                                              #
################################################################################
#$Id: SystemTestReport.pl,v 1.1.2.2 2009/09/04 09:04:11 rfrance Exp $
################################################################################

#$ATSXRDSIZEMAX=15000;
$ATSXRDSIZEMAX=50000000 unless($ATSXRDSIZEMAX);

################################################################################
# SystemTest atsmerge  
################################################################################
sub atsmerge #(\@\@)
{
my ($tdcs,$rios)=@_;

	my $FileList;
	my $res;
	$ATPMODE=0;
	$ATQMODE=0;
	$ATCMODE=0;
	$ATTMODE=0;
	foreach $elem (@$tdcs)
	{
	    if($elem ne '')
	    {
	    	if(-r $elem)
	    	{
		    	$res|=1;
			$FileList.="\"$elem\" ";
		}
	    }
	}
	foreach $elem (@$rios)
	{
	    if($elem ne '')
	    {
	    	if(-r $elem)
	    	{
		    	$res|=2;
			$FileList.="\"$elem\" ";
			ParseAtsRioFile($elem);
		}
	    }
	}
	if($res == 3)
	{
		my $Options="";
		$Options.="-RA=$ATS_RA" if ($ATS_RA && ($ATS_RA ne "NONE"));
		$Options.=" -VA=$ATS_VAL_DISP" if ($ATS_VAL_DISP && ($ATS_VAL_DISP ne "NONE"));
		
		my $headFile="$NAME.summary.txt";
		if(open (HDR,">$headFile")){
		     if($RTRT_ACTIVATED){ #=1 on eclipse
			print HDR "Project=$PROJECT_NAME\n";
			print HDR "Project configuration=$CONFIGURATION\n";
			print HDR "Workspace=$WORKSPACE_PATH\n";
			print HDR "Test name=$NAME\n";
			print HDR "Report file=$NAME.xrd\n";
			print HDR "\$PREPROCESS\n";
			print HDR "\$HEADERLINE\n";
		     }else{
			print HDR "Project=$PROJECT_NAME\n";
			print HDR "Project file=$PROJECT_PATH.rtp\n";
			print HDR "Project configuration=$CONFIGURATION\n";
			print HDR "Workspace=$WORKSPACE_NAME\n";
			print HDR "Test node=$NAME\n";
			print HDR "Report file=".absolutePath("$NAME.xrd")."\n";
			print HDR "\$PREPROCESS\n";
			print HDR "\$HEADERLINE\n";
		     }
		     close HDR;
		}

		if($Ini{'REPORTHEADER'}) {
		     print "REPORTHEADER specified as:$TARGETDIR/cmd/$Ini{'REPORTHEADER'}\n";
		     print "sub reportHeader($headFile,$RTRT_ACTIVATED)\n";
		     require "$TARGETDIR/cmd/$Ini{'REPORTHEADER'}";
		     reportHeader($headFile,$RTRT_ACTIVATED);
		}

		print &PerlTranslate("SystemTestReport.pl", "\nPostprocessing results...\n");
		print "*****************************************************\n"; # NO TRANSLATION
		my $status=SystemP("$BINDIR/atsmerge $FileList $Options -RDD=\"$NAME.rdd\"");
		if ($status>3)
		{
			print &PerlTranslate("SystemTestReport.pl", "Failed.\n");
			return 1;
		}
		open ( LOG, ">$LOGFILENAME" ) or die &PerlTranslate("SystemTestReport.pl", "Cannot open log file.\n");
		print  LOG "XRD $NAME.xrd\n";
		print  LOG "TSF $NAME.tsf\n";
		print  LOG "TDF $NAME.tdf\n";
		print  LOG "DUM $NAME.hdr\n";
		foreach $elem (@$rios)
		{
		    if($elem ne '')
		    {
			print  LOG "DUM $elem\n";
			print  LOG "DUM $elem.bak\n";
			$elem=~s/\.rio$/.rod/;
			print  LOG "DUM $elem\n";
		    }
		}
		if(-s "$NAME.xrd" > $ATSXRDSIZEMAX)
		{
			foreach(SplitSystemTestXrd("$NAME.xrd")){
				print  LOG "DUM $_\n";
			}
		}
		close( LOG );
	}
	else
	{
	   my $filetype="rio and tdc";
	   $filetype="rio" if($res == 1);
	   $filetype="tdc" if($res == 2);
		print &PerlTranslate("SystemTestReport.pl", "$filetype files does not exist\nexpecting:%1 and %2\n","",join(',',@$tdcs),join(',',@$rios));
		return 1;
	}
return 0;
}

################################################################################
# SplitSystemTestXrd
# Arguments:
#   $xrd : xrd file to split
################################################################################
sub SplitSystemTestXrd #($)
{
  my $xrd=shift;
  my @files;
  my $xrdout;
  my $filenum=0;
  my $size=$ATSXRDSIZEMAX;
  my $blocksize;
  my $filter=0;
  my $tag;
  my $name;
  my $state=100;
  my $section=0;
  my $node=0;
  my $fileHeader;
  if(open (ORG, $xrd )) {
  	print &PerlTranslate("SystemTestReport.pl", "Splitting XRD file.\n");
  	my ($dir,$base,$e)=SplitFileName($xrd);
  	open ( SUM, ">$xrd.tmp") or die &PerlTranslate("SystemTestReport.pl", "Cannot open summary xrd file.\n");
  	while(<ORG>) {
  		$size=0 if(/<\/DOCUMENT>/);#do not split at the end of file
		if(($size >= $ATSXRDSIZEMAX) && !(/<\/XROD:NODE>/) && !(/<\/SECTION>/) && !(/<PAGE_BREAK\/>/)) {my $x;
			if($xrdout){
				$x=$node; while($x>0) {$x=$x-1;print OU "</XROD:NODE>\n";}
				$x=$section; while($x>0) {$x=$x-1;print OU "</SECTION>$x\n";}
				print OU "</DOCUMENT>\n</APIDOC>\n</XROD>\n";

				close OU ;
			}
			$size=0;
			$filenum++;
			$xrdout=$base.$filenum.'.xrd';
			open ( OU, ">$dir$xrdout") or die &PerlTranslate("SystemTestReport.pl", "Cannot open splitted xrd file.\n");
			push(@files,$dir.$xrdout);
			print OU $fileHeader;
			$x=$section; while($x>0) {$x=$x-1;print OU "<SECTION>\n";}
			$x=$node;    while($x>0) {$x=$x-1;print OU "<XROD:NODE>\n";}

		}
		print OU;
		$blocksize+=length($_);
		#memo xrd header (first section)
		$fileHeader.=$_ if($state==100);
		#count deth level
		if(/<XROD:NODE /) {$node++;}
		if(/<SECTION/) {$section++; }
		
		#filter block content for Master xrd until </XROD:NODE>
		if(/<\/XROD:NODE>/) {$state=0; $filter=0;$node--;$size+=$blocksize; $blocksize=0;$node=0 if($node<0);}
		if(/<\/SECTION>/) {$state=0; $filter=0; $section--; $size+=$blocksize; $blocksize=0; $size=$ATSXRDSIZEMAX if($size > ($ATSXRDSIZEMAX/10*7));$section=0 if($section<0);}
		#filter XROD:NODE type="Waited Events" or "Received Events" and add a link to splitted xrd for detail
		$state=1 if($state==0 && /type=.Waited Events/);
		$state=1 if($state==0 && /type=.Received Events/);
		$state=2 if($state==1 && /<TITLE LEVEL=/);
		if($state==2 && /TAG=.(\w+).\s/) {$state=3; $tag=$1;}
		if($state==3 && s/<TEXT>/<LINK TARGET=\"$xrdout#$tag\"><TEXT>/){$state=4; s|STYLE=\"[\w ]+\"|STYLE=\"Link\"|;}
		$state=5 if($state==4 && s/<\/TITLE>/<\/LINK><\/TITLE>/);
		if($state==5 && /<TABLE/) {$state=6; $filter=1;}

		#filter XROD:NODE type="Waittil" and add a link to splitted xrd for detail
		$state=10 if($state==0 && /type=.Waittil/);
		if($state==10 && /<TITLE LEVEL=/ && /TAG=.(\w+).\s/){$state=11; $tag=$1;}
		if($state==11 && /<\/TITLE>/){$state=12;}
		if($state==12 && /<TITLE LEVEL=/){$state=13; s/<LINK TARGET=[^>]*>/<LINK TARGET=\"$xrdout#$tag\">/; s|STYLE=\"[\w ]+\"|STYLE=\"Link\"|;} 	
		if($state==13 && /<\/TITLE>/){$state=14;}
		if($state==14 && /<TITLE LEVEL=/) {$state=15; $filter=1;}

		#filter XROD:NODE type="Send Events" and add a link to splitted xrd for detail
		if($state==0 && /type=.Send Events/ && /name=.SEND \((\w+)/){$name=$1;$state=20;}
		if($state==20 && /<TITLE LEVEL=/ && /TAG=.(\w+).\s/){$state=21; $tag=$1;}
		if($state==21 && /<TABLE /){$state=22; $filter=1; print SUM "<TITLE LEVEL=\"3\" STYLE=\"Link\"><LINK TARGET=\"$xrdout#$tag\"><TEXT>$name</TEXT>\n</LINK>\n</TITLE>\n";}

		#filter XROD:NODE type="Call" and add a link to splitted xrd for detail
		if($state==0 && /type=.Call/ && /name=.CALL (\w+)/){$name=$1;$state=30;}
		if($state==30 && /<TITLE LEVEL=/ && /TAG=.(\w+).\s/){$state=31; $tag=$1;}
		if($state==31 && /<TABLE /){$state=32; $filter=1; print SUM "<TITLE LEVEL=\"3\" STYLE=\"Link\"><LINK TARGET=\"$xrdout#$tag\"><TEXT>$name</TEXT>\n</LINK>\n</TITLE>\n";}

		print SUM unless($filter);
  	}
  close ORG;
  close OU;
  close SUM;
  }
  rename("$xrd.tmp",$xrd);
  return @files;
}

1;
