#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2009 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################
#$Id: rtErrors.pl,v 1.2.2.1 2009/06/23 13:32:16 build Exp $
################################################################################
use bytes;
 
my @runtimeError02 = (
"Warning: Internal runtime variables modified by code under Test",
"Coverage: A composition of conditions evaluates in an unexpected result, contact your vendor",
"Coverage: A composition of conditions reached with an unexpected input vector, contact your vendor"
);

my @runtimeErrorAZ = (
"longjmp customization error",
"_att_method_return(): runtime analysis stack data is corrupted",
"_att_note_tsf(): runtime analysis stack data is corrupted",
"_att_delete_instance(): runtime analysis stack data is corrupted",
"_att_method_entry(): runtime analysis stack data is corrupted",
"_atl_threads_get_status CREATION WARNING",
"_att_c_start_function(): runtime analysis stack data is corrupted",
"_atl_get_stack_current(): runtime analysis stack data is corrupted",
"_att_throw_exception(): runtime analysis stack data is corrupted",
"Observation Tools: Mismatch between tools selection for TDP compilation and for instrumentation; check your settings and command-line (Trace/Memory Profiling/Performance Profiling)",
"_atl_stack_link_pop(): runtime analysis stack data is corrupted",
"longjmp table overflow re-define RTRT_NB_SET_JMP",
"PurifyLT: No memory left",
"_att_new_instance(): runtime analysis stack data is corrupted",
"Cannot open traces file",
"_atq_end_now(): runtime analysis stack data is corrupted",
"_atq_start(): runtime analysis stack data is corrupted",
"_atq_end(): runtime analysis stack data is corrupted",
"_att_source_file(): runtime analysis stack data is corrupted",
"Trace: Can't catch signal",
"_att_do_print_stack(): runtime analysis stack data is corrupted",
"_att_thread_create(): runtime analysis stack data is corrupted",
"_att_check_process(): runtime analysis stack data is corrupted",
"_att_catch_exception(): runtime analysis stack data is corrupted",
"attempt to use Target Deployment Port resources after exit handler has been called (level 4)"
);

my @runtimeErroraz = (
"getenv ATS_PORT_TSTAGT",
"bad socket",
"RDV connect",
"TSTAGT connect",
"exit function not implemented",
"free not implemented",
"memcpy not implemented in this TDP",
"Maximum number of threads reached",
"interrecv select",
"malloc not implemented",
"getpid not implemented in this TDP",
"realloc not implemented",
"No memory left",
"realloc not user-definable in this release",
"warning: sleep function not implemented",
"getenv ATS_PORT_RDV",
"_atl_threads_get_index Unknow thread",
"socket recv",
"socket",
"warning: tester-agent link (RTRT_DYNAMIC_TRACKING) not implemented",
"try to kill unknown thread",
"warning: rendez-vous not implemented",
"write",
"send_with_checking",
"read write",
"FATAL ERROR on sprintf Please contact your administrative"
);


################################################################################
# use the ATL_ERROR to get the runtime error message correponding to the error code
# Arguments:
#   input: runtime error code found on the WA line in the .spt file or .rej
# Return value:
#   output: message string
################################################################################
sub ATL_ERROR
{
	my $code = shift;
	return $runtimeErrorAZ[ord($code)-ord('A')] if($code=~/[A-Z]/) ;
	return $runtimeErroraz[ord($code)-ord('a')] if($code=~/[a-z]/) ;
	return $runtimeError02[ord($code)-ord('0')] if($code=~/[0-2]/) ;
	return "Coverage: Mismatch between Coverage Information selection for TDP compilation and for instrumentation; check your settings (Coverage Information: Default/Compact Hit Data/Count Information) or command-line options (Pass/Compact/Count)" if($code eq ' ');
	return "Coverage: Can't catch signal" if(ord($code) == 40);
return "unknown error";
}

