/*
  Licensed Materials - Property of IBM
  Restricted Material of IBM
  IBM Rational Test RealTime
  (c) Copyright IBM Corp. 2003-2004 All Rights Reserved.

  US Governement Users Restricted Rights - Use, duplication or
  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
/* AtsMain.c for Linux V1.2 richard.france */
/* This AtsMain.c[pp] is a thread launcher for system testing
        It should be located in the targets/<target>/lib directory
        It is used when Virtual testers are generated as threads and this file exist in the TDP
        The execution command line format is -thread=rioFileName,instanceName,occurence -thread=.....
*/

#include <stdio.h>
#include <stdlib.h>

#define THR_HANDLE pthread_t
#include <pthread.h>
typedef void *(*LPTHREAD_START_ROUTINE)(void*);
void* resultThread;

/*! Expected argument type in start routine of thread mode name of rio file
 * to generate list of filters set. */
typedef struct {
  char *atl_riofilename;
  char *atl_filters;
  char *atl_instance;
  int   atl_occid;
} ATL_T_ARG, *ATL_PT_ARG;
#define ATL_T_THREAD_RETURN void

#define trace printf
#define traceEnd

#ifdef __cplusplus
#define EXTERN extern "C"
#else
#define EXTERN extern
#endif
EXTERN int atl_strncmp(char*, char*, int);

typedef struct {
        ATL_T_ARG       ArgThread;
        THR_HANDLE      HndThread;
} ATL_T_Thread, *ATL_PT_Thread;

#ifndef ATL_Start
#define THREADSTABLELEN ATL_Start_TableLen
#define THREADSTABLE ATL_Start_Table
#endif
#ifdef  THREADSTABLELEN
extern int THREADSTABLELEN;
extern char * THREADSTABLE[];
#endif
extern ATL_T_THREAD_RETURN  ATL_Start(ATL_PT_ARG arg);

int main(int argc, char **argv)
{
 int threadNo=0;
 pthread_attr_t attr;
 int NB_THREAD=0;
 ATL_PT_Thread pThread,pThread1;
 int i;
 char *c,*p;

 if(argc >1)
   {
 	  pThread1=malloc(argc*sizeof(ATL_T_Thread));
 	  pThread=pThread1;
	  for (threadNo=1 ; threadNo < argc ;threadNo++)
	   {
		if ((atl_strncmp(argv[threadNo], "-THREAD=", 8) == 0) || (atl_strncmp(argv[threadNo], "-thread=", 8) == 0))
		 {
			  p=&argv[threadNo][8];
			  pThread->ArgThread.atl_riofilename=p;
			  pThread->ArgThread.atl_filters="";
			  for(; *p && *p!=',';p++);
			  *p++=0;
			  pThread->ArgThread.atl_instance=p;
			  for(; *p && *p!=',';p++);
			  *p++=0;
			  if(*p) pThread->ArgThread.atl_occid=atoi(p);
		 	  NB_THREAD++;
		 	  pThread++;
		 }
	   }
	   trace("found %d instances on cmd line\n",NB_THREAD);
   }
#ifdef THREADSTABLELEN
   else
   {
	 NB_THREAD=THREADSTABLELEN;
	 pThread1=malloc(NB_THREAD*sizeof(ATL_T_Thread));
	 pThread=pThread1;
	 threadNo=0;
	 while(threadNo<NB_THREAD)
	 {
		   c=THREADSTABLE[threadNo];
		   p=malloc(strlen(c)+4+1);
		   pThread->ArgThread.atl_instance=c;
		   pThread->ArgThread.atl_riofilename=p;
		   while(*c){*p++=*c++;}
		   c=".rio";
		   while(*c){*p++=*c++;}
		   *p=0;
		   pThread->ArgThread.atl_filters="";
		   pThread->ArgThread.atl_occid=0;
		trace("Instance %s => %s \n",pThread->ArgThread.atl_instance, pThread->ArgThread.atl_riofilename);
		   pThread++;
		   threadNo++;
	 }
   }
#endif
	/* threads creation */
	threadNo=0;
	pThread=pThread1;
	while(threadNo<NB_THREAD)
	{
			 i = pthread_create(&(pThread->HndThread)
					,NULL /* attibutes */
				,(LPTHREAD_START_ROUTINE) ATL_Start /* pointer to thread function */
				,(void *)&pThread->ArgThread     /* argument for new thread */
					);
			trace("Instance %s created code %d\n",pThread->ArgThread.atl_instance,i);traceEnd
			if(i) printf("Instance %s Creation error %d\n",pThread->ArgThread.atl_instance,i);
			threadNo++;
		pThread++;
	}

	/* wait threads end */
	threadNo=0;
	pThread=pThread1;
	while(threadNo<NB_THREAD)
	{
			i=pthread_join(pThread->HndThread, &resultThread);
			{
					printf("instance %s (No %d) exit code: %8X\n", pThread->ArgThread.atl_instance, pThread->HndThread,resultThread);
			pThread++;
					threadNo++;
			}
	}
	return 0;
}
